'******************************************************************************
'                COMICS Database Include file for TURBO-BASIC ACCESS
'		
' Dataset reference No:  COMICS.File
' Data file name:        COMICS.DBD
' Data File length:       276
' Key File name:         COMICS.DBI
' Key length:             44

'******************************************************************************

IF COMICS.File > 0 THEN GOTO EndCOMICSInc 'skip if already open
  INCR LastFileNum
  COMICS.File = LastFileNum
  COMICS.RLen =  276
  COMICS.KLen =  44

  CALL dbCreate(COMICS.File, FileNo, _
    "COMICS.DBI", COMICS.KLen, "COMICS.DBD", COMICS.RLen)

  IF dbStatus = %FileAlreadyCreated THEN _
    CALL dbOpen(COMICS.File, FileNo,      _
      "COMICS.DBI", COMICS.KLen, COMICS.RLen)

  IF COMICS.RLen <>  276 THEN
    PRINT "COMICS.DBD length is inconsistent with this program."
    END
  ELSEIF COMICS.KLen <>  44 THEN
    PRINT "COMICS.DBI key length is inconsistent with this program."
    END
  END IF

  field FileNo,_
    4 as COMICS.Skip$,_
    40 as COMICS.Title$,_
    1 as COMICS.Volume$,_
    3 as COMICS.Issue$,_
    20 as COMICS.Company$,_
    20 as COMICS.Editor$,_
    20 as COMICS.Writer$,_
    20 as COMICS.Penciler$,_
    20 as COMICS.Inker$,_
    6 as COMICS.Price$,_
    3 as COMICS.Mint$,_
    3 as COMICS.Fine$,_
    3 as COMICS.Good$,_
    3 as COMICS.Total$,_
    7 as COMICS.WorthMint$,_
    7 as COMICS.WorthFine$,_
    7 as COMICS.WorthGood$,_
    7 as COMICS.WorthTotal$,_
    5 as COMICS.PercentMint$,_
    5 as COMICS.PercentFine$,_
    5 as COMICS.PercentGood$,_
    5 as COMICS.PercentTotal$,_
    2 as COMICS.Box$,_
    60 as COMICS.Notes$


  FIELD FileNo,  276 AS COMICS.Buffer$

  GOSUB COMICSClear
GOTO EndCOMICSInc:

COMICSClear:
  LSET COMICS.Buffer$ = STRING$(  276, " ")
RETURN 'COMICSClear

EndCOMICSInc: 'End of this include file